-- ZB_DM_CXWJDD ZB_DM_车险未决大单
-- bigclpbdt/日期
-- 估损调整日期在今天，按照估损金额排序，取前20，车险riskcode 05开头，其他为非车，


-- 去重
CREATE TEMPORARY VIEW VIEW_ZB_DM_CXWJDD AS
select
    *
from (

         select
               `setdate`                             as `setdate`      
              ,`LEVEL1COMCODE`                       as `LEVEL1COMCODE`
              ,`LEVEL1COMDESC`                       as `LEVEL1COMDESC`
              ,`LEVEL2COMDESC`                       as `LEVEL2COMDESC`
              ,`LEVEL2COMCODE`                       as `LEVEL2COMCODE`
              ,`LEVEL3COMCODE`                       as `LEVEL3COMCODE`
              ,`LEVEL3COMDESC`                       as `LEVEL3COMDESC`
              ,`no`                                  as `no`           
              ,`claimno`                             as `claimno`      
              ,cast(`lossamout` as DECIMAL(18,2)) - cast(`settledamount` as DECIMAL(18,2))  as `cost`
              ,`risk`                                as `risk`
              ,`riskname`                            as `riskname`
              ,`chnl`                                as `chnl`
              ,`chnlname`                            as `chnlname`
         from ZB_ODS.ZB_ODS_KAFKA.LPDATA
         where `COMNAME` is not null
           and `flag` = 'wj'
           and LEFT(`setdate`,8) = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
     ) s1
where LEFT(s1.`risk`,2) = '05'
;



-- 总公司
insert into ZB_DM.ZB_DM_REDIS.SET_VARCHAR
select 
    CONCAT(
        'bigclpbdt/'
        ,s1.`setdate`
    )                      as `key` 
    ,CastToJsonArrayUDF(
        listagg(concat(
             'com'      ,':'  ,s1.`com`      ,',' 
            ,'maincom'  ,':'  ,s1.`maincom`  ,',' 
            ,'no'       ,':'  ,s1.`no`       ,',' 
            ,'claimno'  ,':'  ,s1.`claimno`  ,',' 
            ,'cost'     ,':'  ,cast (s1.`cost` as varchar )   ,',' 
            ,'comname'  ,':'  ,s1.`comname`  ,',' 
            ,'chnl'     ,':'  ,s1.`chnl`     ,',' 
            ,'mainkey'  ,':'  ,s1.`mainkey`  ,',' 
            ,'riskname' ,':'  ,s1.`riskname` ,',' 
            ,'chnlname' ,':'  ,s1.`chnlname` ,',' 
            ,'risk'     ,':'  ,s1.`risk`
        ),';')
    )                      as `val` 
from (
    select
        *
    from(
        select
            d1.`setdate`                                        as `setdate`
            ,d1.`LEVEL1COMCODE`                                 as `com`
            ,d1.`LEVEL1COMDESC`                                 as `comname`    
            ,d1.`LEVEL1COMCODE`                                 as `maincom` 
            ,d1.`no`                                            as `no`      
            ,d1.`claimno`                                       as `claimno` 
            ,d1.`cost`                                          as `cost`
            ,d1.`chnl`                                          as `chnl` 
            ,d1.`chnlname`                                      as `chnlname`   
            ,CONCAT(d1.`LEVEL1COMCODE`,'/',d1.`claimno`,'/',d1.`no`)      as `mainkey`               
            ,d1.`risk`                                          as `risk`  
            ,d1.`riskname`                                      as `riskname`   
            ,ROW_NUMBER() OVER(PARTITION BY d1.`setdate` ORDER BY d1.`cost` DESC) as rownum
        from VIEW_ZB_DM_CXWJDD d1
    ) c1
    where c1.rownum <= 20 
) s1
group by 
    s1.`setdate`
;



-- 分公司
insert into ZB_DM.ZB_DM_REDIS.SET_VARCHAR
select 
    CONCAT(
        'bigcitylpbdt/' 
        ,s1.`setdate`
        ,'/',s1.`group_com`
    )                      as `key` 
    ,CastToJsonArrayUDF(
        listagg(concat(
            'com'      ,':'  ,s1.`com`      ,','
           ,'maincom'  ,':'  ,s1.`maincom`  ,','
           ,'city'     ,':'  ,s1.`city`     ,','
           ,'cityname' ,':'  ,s1.`cityname` ,','
           ,'no'       ,':'  ,s1.`no`       ,','
           ,'claimno'  ,':'  ,s1.`claimno`  ,','
           ,'cost'     ,':'  ,cast (s1.`cost` as varchar )     ,','
           ,'comname'  ,':'  ,s1.`comname`  ,','
           ,'chnl'     ,':'  ,s1.`chnl`     ,','
           ,'mainkey'  ,':'  ,s1.`mainkey`  ,','
           ,'riskname' ,':'  ,s1.`riskname` ,','
           ,'chnlname' ,':'  ,s1.`chnlname` ,','
           ,'risk'     ,':'  ,s1.`risk`
        ),';')
    )                      as `val` 
from (
    select
        *
    from (
        select
             d1.`setdate`                                       as `setdate`
            ,d1.`LEVEL1COMCODE`                                 as `group_com`
            ,d1.`LEVEL1COMCODE`                                 as `com`  
            ,d1.`LEVEL1COMDESC`                                 as `comname`    
            ,d1.`LEVEL1COMCODE`                                 as `maincom`
            ,d1.`LEVEL2COMDESC`                                 as `city`    
            ,d1.`LEVEL2COMCODE`                                 as `cityname` 
            ,d1.`no`                                            as `no`      
            ,d1.`claimno`                                       as `claimno` 
            ,d1.`cost`                                          as `cost`
            ,d1.`chnl`                                          as `chnl` 
            ,d1.`chnlname`                                      as `chnlname`   
            ,CONCAT(d1.`LEVEL1COMCODE`,'/',d1.`claimno`,'/',d1.`no`)      as `mainkey`               
            ,d1.`risk`                                          as `risk`  
            ,d1.`riskname`                                      as `riskname`   
            ,ROW_NUMBER() OVER(PARTITION BY d1.`LEVEL1COMCODE`,d1.`setdate` ORDER BY d1.`cost` DESC) as rownum
        from VIEW_ZB_DM_CXWJDD d1
    ) c1
    where c1.rownum <= 20 
) s1
group by 
    s1.`setdate`
    ,s1.`group_com`
;


-- 中支
insert into ZB_DM.ZB_DM_REDIS.SET_VARCHAR
select
    CONCAT(
            'bigcountrylpbdt/'
        ,s1.`setdate`
        ,'/',s1.`group_com`
        )                      as `key`
     ,CastToJsonArrayUDF(
        listagg(concat(
             'com'         ,':'  ,s1.`com`         ,','
            ,'maincom'     ,':'  ,s1.`maincom`     ,','
            ,'city'        ,':'  ,s1.`city`        ,','
            ,'cityname'    ,':'  ,s1.`cityname`    ,','
            ,'country'     ,':'  ,s1.`country`     ,','
            ,'countryname' ,':'  ,s1.`countryname` ,','
            ,'no'          ,':'  ,s1.`no`          ,','
            ,'claimno'     ,':'  ,s1.`claimno`     ,','
            ,'cost'        ,':'  ,cast (s1.`cost` as varchar )     ,','
            ,'comname'     ,':'  ,s1.`comname`     ,','
            ,'chnl'        ,':'  ,s1.`chnl`        ,','
            ,'mainkey'     ,':'  ,s1.`mainkey`     ,','
            ,'riskname'    ,':'  ,s1.`riskname`    ,','
            ,'chnlname'    ,':'  ,s1.`chnlname`    ,','
            ,'risk'        ,':'  ,s1.`risk`
            ),';')
        )                      as `val`
from (
     select
         *
     from (
        select
             d1.`setdate`                                       as `setdate`
            ,d1.`LEVEL2COMCODE`                                 as `group_com`
            ,d1.`LEVEL1COMCODE`                                 as `com` 
            ,d1.`LEVEL1COMDESC`                                 as `comname`    
            ,d1.`LEVEL1COMCODE`                                 as `maincom`
            ,d1.`LEVEL2COMDESC`                                 as `city`    
            ,d1.`LEVEL2COMCODE`                                 as `cityname` 
            ,d1.`LEVEL3COMCODE`                                 as `country`
            ,d1.`LEVEL3COMDESC`                                 as `countryname`
            ,d1.`no`                                            as `no`      
            ,d1.`claimno`                                       as `claimno` 
            ,d1.`cost`                                          as `cost`
            ,d1.`chnl`                                          as `chnl`
            ,d1.`chnlname`                                      as `chnlname`   
            ,CONCAT(d1.`LEVEL1COMCODE`,'/',d1.`claimno`,'/',d1.`no`)      as `mainkey`              
            ,d1.`risk`                                          as `risk`
            ,d1.`riskname`                                      as `riskname`   
            ,ROW_NUMBER() OVER(PARTITION BY d1.`LEVEL2COMCODE`,d1.`setdate` ORDER BY d1.`cost` DESC) as rownum
         from VIEW_ZB_DM_CXWJDD d1
          ) c1
     where c1.rownum <= 20
     ) s1
group by
    s1.`setdate`
   ,s1.`group_com`
;

